Index: common-core/src/test/java/org/teiid/core/types/TestDataTypeManager.java
===================================================================
--- common-core/src/test/java/org/teiid/core/types/TestDataTypeManager.java	(revision 3801)
+++ common-core/src/test/java/org/teiid/core/types/TestDataTypeManager.java	(working copy)
@@ -159,15 +159,13 @@
     
     @Test public void testJDBCSQLTypeInfo() {
         
-        String[] types = JDBCSQLTypeInfo.getMMTypeNames();
+        Set<String> types = JDBCSQLTypeInfo.getMMTypeNames();
         
-        for (int i = 0; i < types.length; i++) {
-            String type = types[i];
-            
+        for (String type : types) {
             assertEquals("Didn't get match for "+ type, JDBCSQLTypeInfo.getSQLType(type), JDBCSQLTypeInfo.getSQLTypeFromRuntimeType(DataTypeManager.getDataTypeClass(type))); //$NON-NLS-1$
             
             //the classnames will not match the runtime types for xml, clob, blob
-            if (!type.equalsIgnoreCase(DataTypeManager.DefaultDataTypes.XML) && !type.equalsIgnoreCase(DataTypeManager.DefaultDataTypes.CLOB) && !type.equalsIgnoreCase(DataTypeManager.DefaultDataTypes.BLOB)) {
+            if (!type.equalsIgnoreCase(DataTypeManager.DefaultDataTypes.NULL) && !type.equalsIgnoreCase(DataTypeManager.DefaultDataTypes.VARBINARY) && !type.equalsIgnoreCase(DataTypeManager.DefaultDataTypes.XML) && !type.equalsIgnoreCase(DataTypeManager.DefaultDataTypes.CLOB) && !type.equalsIgnoreCase(DataTypeManager.DefaultDataTypes.BLOB)) {
                 assertEquals("Didn't get match for "+ type, JDBCSQLTypeInfo.getSQLType(type), JDBCSQLTypeInfo.getSQLTypeFromClass(DataTypeManager.getDataTypeClass(type).getName())); //$NON-NLS-1$
             }
         }
Index: client/src/test/java/org/teiid/jdbc/TestAllResultsImpl.java
===================================================================
--- client/src/test/java/org/teiid/jdbc/TestAllResultsImpl.java	(revision 3801)
+++ client/src/test/java/org/teiid/jdbc/TestAllResultsImpl.java	(working copy)
@@ -46,7 +46,7 @@
 import org.teiid.client.ResultsMessage;
 import org.teiid.client.util.ResultsFuture;
 import org.teiid.core.TeiidProcessingException;
-import org.teiid.core.types.JDBCSQLTypeInfo;
+import org.teiid.core.types.DataTypeManager;
 import org.teiid.core.util.TimestampWithTimezone;
 import org.teiid.query.unittest.TimestampUtil;
 
@@ -696,7 +696,7 @@
 	}
     
     @Test(expected=TeiidSQLException.class) public void testResultsMessageException() throws Exception {
-        ResultsMessage resultsMsg = exampleMessage(exampleResults1(1), new String[] { "IntNum" }, new String[] { JDBCSQLTypeInfo.INTEGER }); //$NON-NLS-1$
+        ResultsMessage resultsMsg = exampleMessage(exampleResults1(1), new String[] { "IntNum" }, new String[] { DataTypeManager.DefaultDataTypes.INTEGER }); //$NON-NLS-1$
         resultsMsg.setFinalRow(-1);
         ResultsMessage next = new ResultsMessage();
         next.setException(new Throwable());
@@ -769,8 +769,8 @@
 
 	private String[] dataTypes() {
 		String[] types = new String[2];
-		types[0] = JDBCSQLTypeInfo.INTEGER;
-		types[1] = JDBCSQLTypeInfo.STRING;
+		types[0] = DataTypeManager.DefaultDataTypes.INTEGER;
+		types[1] = DataTypeManager.DefaultDataTypes.STRING;
 		return types;
 	}
 
@@ -791,7 +791,7 @@
 
 	/** without metadata info. */
 	private ResultsMessage exampleResultsMsg1() {
-		return exampleMessage(exampleResults1(5), new String[] { "IntNum" }, new String[] { JDBCSQLTypeInfo.INTEGER }); //$NON-NLS-1$
+		return exampleMessage(exampleResults1(5), new String[] { "IntNum" }, new String[] { DataTypeManager.DefaultDataTypes.INTEGER }); //$NON-NLS-1$
 	}
 	
 	private ResultsMessage exampleMessage(List<Object>[] results, String[] columnNames, String[] datatypes) {
@@ -809,7 +809,7 @@
 
 	/** without metadata info. */
 	private ResultsMessage exampleResultsMsg2() {
-		return exampleMessage(exampleResults2(), new String[] { "IntNum", "StringNum" }, new String[] { JDBCSQLTypeInfo.INTEGER, JDBCSQLTypeInfo.STRING }); //$NON-NLS-1$ //$NON-NLS-2$
+		return exampleMessage(exampleResults2(), new String[] { "IntNum", "StringNum" }, new String[] { DataTypeManager.DefaultDataTypes.INTEGER, DataTypeManager.DefaultDataTypes.STRING }); //$NON-NLS-1$ //$NON-NLS-2$
 	}
 
 	/** with limited metadata info. */
@@ -828,7 +828,7 @@
 
 	/** no rows. */
 	private ResultsMessage exampleResultsMsg3() {
-		return exampleMessage(new List[0], new String[] { "IntNum", "StringNum" }, new String[] { JDBCSQLTypeInfo.INTEGER, JDBCSQLTypeInfo.STRING }); //$NON-NLS-1$ //$NON-NLS-2$
+		return exampleMessage(new List[0], new String[] { "IntNum", "StringNum" }, new String[] { DataTypeManager.DefaultDataTypes.INTEGER, DataTypeManager.DefaultDataTypes.STRING }); //$NON-NLS-1$ //$NON-NLS-2$
 	}
 	
 	private static ResultsMessage exampleResultsMsg4(int begin, int length, boolean lastBatch) {
@@ -838,7 +838,7 @@
 		List[] results = exampleResults1(length, begin);
 		resultsMsg.setResults(results);
 		resultsMsg.setColumnNames(new String[] { "IntKey" }); //$NON-NLS-1$
-		resultsMsg.setDataTypes(new String[] { JDBCSQLTypeInfo.INTEGER }); 
+		resultsMsg.setDataTypes(new String[] { DataTypeManager.DefaultDataTypes.INTEGER }); 
 		resultsMsg.setFirstRow(begin);
 		if (lastBatch) {
 			resultsMsg.setFinalRow(begin + results.length - 1);
@@ -865,7 +865,7 @@
 		ResultsMessage resultsMsg = new ResultsMessage();
 		resultsMsg.setResults(new List[] {Arrays.asList(new Timestamp(0))});
 		resultsMsg.setColumnNames(new String[] { "TS" }); //$NON-NLS-1$
-		resultsMsg.setDataTypes(new String[] { JDBCSQLTypeInfo.TIMESTAMP }); 
+		resultsMsg.setDataTypes(new String[] { DataTypeManager.DefaultDataTypes.TIMESTAMP }); 
 		resultsMsg.setFirstRow(1);
 		resultsMsg.setFinalRow(1);
 		resultsMsg.setLastRow(1);
@@ -882,7 +882,7 @@
 	
 	@Test public void testWasNull() throws SQLException{
 		ResultsMessage message = exampleMessage(new List[] { Arrays.asList((String)null), Arrays.asList("1") }, new String[] { "string" }, //$NON-NLS-1$
-				new String[] { JDBCSQLTypeInfo.STRING });
+				new String[] { DataTypeManager.DefaultDataTypes.STRING });
 		ResultSetImpl rs = new ResultSetImpl(message, statement);
 		assertTrue(rs.next());
 		assertEquals(Boolean.FALSE.booleanValue(), rs.getBoolean(1));
@@ -909,7 +909,7 @@
 		TimeZone.setDefault(TimeZone.getTimeZone("GMT-05:00")); //$NON-NLS-1$
 		ResultsMessage message = exampleMessage(new List[] { Arrays.asList(1, TimestampUtil.createTime(0, 0, 0), TimestampUtil.createDate(1, 1, 1), TimestampUtil.createTimestamp(1, 1, 1, 1, 1, 1, 1), "<root/>") }, //$NON-NLS-1$ 
 				new String[] { "int", "time", "date", "timestamp", "sqlxml" }, //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$ //$NON-NLS-5$ 
-				new String[] { JDBCSQLTypeInfo.INTEGER, JDBCSQLTypeInfo.TIME, JDBCSQLTypeInfo.DATE, JDBCSQLTypeInfo.TIMESTAMP, JDBCSQLTypeInfo.STRING });
+				new String[] { DataTypeManager.DefaultDataTypes.INTEGER, DataTypeManager.DefaultDataTypes.TIME, DataTypeManager.DefaultDataTypes.DATE, DataTypeManager.DefaultDataTypes.TIMESTAMP, DataTypeManager.DefaultDataTypes.STRING });
 		TimestampWithTimezone.resetCalendar(TimeZone.getTimeZone("GMT-06:00")); //$NON-NLS-1$
 		ResultSetImpl rs = new ResultSetImpl(message, statement);
 		assertTrue(rs.next());
Index: client/src/main/java/org/teiid/jdbc/StatementImpl.java
===================================================================
--- client/src/main/java/org/teiid/jdbc/StatementImpl.java	(revision 3801)
+++ client/src/main/java/org/teiid/jdbc/StatementImpl.java	(working copy)
@@ -44,13 +44,13 @@
 import org.teiid.client.RequestMessage.ShowPlan;
 import org.teiid.client.metadata.ParameterInfo;
 import org.teiid.client.metadata.ResultsMetadataConstants;
-import org.teiid.client.metadata.ResultsMetadataDefaults;
 import org.teiid.client.plan.Annotation;
 import org.teiid.client.plan.PlanNode;
 import org.teiid.client.util.ResultsFuture;
 import org.teiid.core.TeiidComponentException;
 import org.teiid.core.TeiidException;
 import org.teiid.core.TeiidProcessingException;
+import org.teiid.core.types.DataTypeManager;
 import org.teiid.core.types.JDBCSQLTypeInfo;
 import org.teiid.core.types.SQLXMLImpl;
 import org.teiid.core.util.SqlUtil;
@@ -503,7 +503,7 @@
         				records.add(row);
         			}
         			createResultSet(records, new String[] {"PLAN_TEXT", "PLAN_XML", "DEBUG_LOG"}, //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
-        					new String[] {JDBCSQLTypeInfo.CLOB, JDBCSQLTypeInfo.XML, JDBCSQLTypeInfo.CLOB});
+        					new String[] {DataTypeManager.DefaultDataTypes.CLOB, DataTypeManager.DefaultDataTypes.XML, DataTypeManager.DefaultDataTypes.CLOB});
         			return booleanFuture(true);
         		}
         		if (show.equalsIgnoreCase("ANNOTATIONS")) { //$NON-NLS-1$
@@ -518,7 +518,7 @@
         				records.add(row);
         			}
         			createResultSet(records, new String[] {"CATEGORY", "PRIORITY", "ANNOTATION", "RESOLUTION"}, //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$
-        					new String[] {JDBCSQLTypeInfo.STRING, JDBCSQLTypeInfo.STRING, JDBCSQLTypeInfo.STRING, JDBCSQLTypeInfo.STRING});
+        					new String[] {DataTypeManager.DefaultDataTypes.STRING, DataTypeManager.DefaultDataTypes.STRING, DataTypeManager.DefaultDataTypes.STRING, DataTypeManager.DefaultDataTypes.STRING});
         			return booleanFuture(true);
         		}
         		if (show.equalsIgnoreCase("ALL")) { //$NON-NLS-1$
@@ -530,11 +530,11 @@
         				records.add(row);
         			}
         			createResultSet(records, new String[] {"NAME", "VALUE"}, //$NON-NLS-1$ //$NON-NLS-2$
-        					new String[] {JDBCSQLTypeInfo.STRING, JDBCSQLTypeInfo.STRING});
+        					new String[] {DataTypeManager.DefaultDataTypes.STRING, DataTypeManager.DefaultDataTypes.STRING});
         			return booleanFuture(true);
         		}
         		List<List<String>> records = Collections.singletonList(Collections.singletonList(driverConnection.getExecutionProperties().getProperty(JDBCURL.getValidKey(show))));
-    			createResultSet(records, new String[] {show}, new String[] {JDBCSQLTypeInfo.STRING});
+    			createResultSet(records, new String[] {show}, new String[] {DataTypeManager.DefaultDataTypes.STRING});
         		return booleanFuture(true);
         	}
         }
@@ -1086,7 +1086,7 @@
 	    metadataMap.put(ResultsMetadataConstants.GROUP_NAME, tableName);
 	    metadataMap.put(ResultsMetadataConstants.ELEMENT_NAME, columnName);
 	    metadataMap.put(ResultsMetadataConstants.DATA_TYPE, dataType);
-	    metadataMap.put(ResultsMetadataConstants.PRECISION, ResultsMetadataDefaults.getDefaultPrecision(dataType));
+	    metadataMap.put(ResultsMetadataConstants.PRECISION, JDBCSQLTypeInfo.getDefaultPrecision(dataType));
 	    metadataMap.put(ResultsMetadataConstants.RADIX, new Integer(10));
 	    metadataMap.put(ResultsMetadataConstants.SCALE, new Integer(0));
 	    metadataMap.put(ResultsMetadataConstants.AUTO_INCREMENTING, Boolean.FALSE);
@@ -1096,7 +1096,7 @@
 	    metadataMap.put(ResultsMetadataConstants.SIGNED, signed);
 	    metadataMap.put(ResultsMetadataConstants.WRITABLE, writable);
 	    metadataMap.put(ResultsMetadataConstants.CURRENCY, Boolean.FALSE);
-	    metadataMap.put(ResultsMetadataConstants.DISPLAY_SIZE, ResultsMetadataDefaults.getMaxDisplaySize(dataType));
+	    metadataMap.put(ResultsMetadataConstants.DISPLAY_SIZE, JDBCSQLTypeInfo.getMaxDisplaySize(dataType));
 	
 	    return metadataMap;
 	}
Index: engine/src/main/java/org/teiid/dqp/internal/process/DQPWorkContext.java
===================================================================
--- engine/src/main/java/org/teiid/dqp/internal/process/DQPWorkContext.java	(revision 3801)
+++ engine/src/main/java/org/teiid/dqp/internal/process/DQPWorkContext.java	(working copy)
@@ -51,17 +51,24 @@
 	private static final long serialVersionUID = -6389893410233192977L;
 	
 	public enum Version {
-		SEVEN_1("7.1"), //$NON-NLS-1$
-		SEVEN_2("7.2"), //$NON-NLS-1$
-		SEVEN_3("7.3"), //$NON-NLS-1$
-		SEVEN_4("7.4"), //$NON-NLS-1$
-		SEVEN_5("7.5"), //$NON-NLS-1$
-		SEVEN_6("7.6"); //$NON-NLS-1$
+		SEVEN_1("7.1", (byte)0), //$NON-NLS-1$
+		SEVEN_2("7.2", (byte)0), //$NON-NLS-1$
+		SEVEN_3("7.3", (byte)0), //$NON-NLS-1$
+		SEVEN_4("7.4", (byte)0), //$NON-NLS-1$
+		SEVEN_5("7.5", (byte)0), //$NON-NLS-1$
+		SEVEN_6("7.6", (byte)0), //$NON-NLS-1$
+		EIGHT_0("8.0", (byte)1); //$NON-NLS-1$
 		
 		private String string;
+		private byte clientSerializationVersion;
 		
-		private Version(String string) {
+		private Version(String string, byte clientSerializationVersion) {
 			this.string = string;
+			this.clientSerializationVersion = clientSerializationVersion;
+		}
+		
+		public byte getClientSerializationVersion() {
+			return clientSerializationVersion;
 		}
 		
 		@Override
Index: common-core/src/main/java/org/teiid/core/types/basic/BlobToBinaryTransform.java
===================================================================
--- common-core/src/main/java/org/teiid/core/types/basic/BlobToBinaryTransform.java	(revision 0)
+++ common-core/src/main/java/org/teiid/core/types/basic/BlobToBinaryTransform.java	(revision 0)
@@ -0,0 +1,76 @@
+/*
+ * JBoss, Home of Professional Open Source.
+ * See the COPYRIGHT.txt file distributed with this work for information
+ * regarding copyright ownership.  Some portions may be licensed
+ * to Red Hat, Inc. under one or more contributor license agreements.
+ * 
+ * This library is free software; you can redistribute it and/or
+ * modify it under the terms of the GNU Lesser General Public
+ * License as published by the Free Software Foundation; either
+ * version 2.1 of the License, or (at your option) any later version.
+ * 
+ * This library is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ * Lesser General Public License for more details.
+ * 
+ * You should have received a copy of the GNU Lesser General Public
+ * License along with this library; if not, write to the Free Software
+ * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
+ * 02110-1301 USA.
+ */
+
+package org.teiid.core.types.basic;
+
+import java.io.IOException;
+import java.sql.SQLException;
+
+import org.teiid.core.CorePlugin;
+import org.teiid.core.types.BinaryType;
+import org.teiid.core.types.BlobType;
+import org.teiid.core.types.DataTypeManager;
+import org.teiid.core.types.Transform;
+import org.teiid.core.types.TransformationException;
+import org.teiid.core.util.ObjectConverterUtil;
+
+
+public class BlobToBinaryTransform extends Transform {
+
+    /**
+     * This method transforms a value of the source type into a value
+     * of the target type.
+     * @param value Incoming value of source type
+     * @return Outgoing value of target type
+     * @throws TransformationException if value is an incorrect input type or
+     * the transformation fails
+     */
+    public Object transformDirect(Object value) throws TransformationException {
+        BlobType source = (BlobType)value;
+        
+        try {
+        	byte[] bytes = ObjectConverterUtil.convertToByteArray(source.getBinaryStream(), DataTypeManager.MAX_LOB_MEMORY_BYTES, true);
+            return new BinaryType(bytes);         
+        } catch (SQLException e) {
+            throw new TransformationException(e, CorePlugin.Util.getString("failed_convert", new Object[] {getSourceType().getName(), getTargetType().getName()})); //$NON-NLS-1$            
+        } catch(IOException e) {
+            throw new TransformationException(e, CorePlugin.Util.getString("failed_convert", new Object[] {getSourceType().getName(), getTargetType().getName()})); //$NON-NLS-1$
+        } 
+    }
+
+    /** 
+     * @see org.teiid.core.types.Transform#isExplicit()
+     */
+    public boolean isExplicit() {
+        return true;
+    }
+
+	@Override
+	public Class<?> getSourceType() {
+		return DataTypeManager.DefaultDataClasses.BLOB;
+	}
+
+	@Override
+	public Class<?> getTargetType() {
+		return DataTypeManager.DefaultDataClasses.VARBINARY;
+	}
+}
Index: client/src/test/java/org/teiid/jdbc/util/ResultSetUtil.java
===================================================================
--- client/src/test/java/org/teiid/jdbc/util/ResultSetUtil.java	(revision 3801)
+++ client/src/test/java/org/teiid/jdbc/util/ResultSetUtil.java	(working copy)
@@ -553,7 +553,7 @@
         private BufferedReader in;
         private int line = 0;
         
-        private ArrayList unequalLines = new ArrayList();
+        private ArrayList<String> unequalLines = new ArrayList<String>();
         
         private ComparingPrintStream(OutputStream out, BufferedReader in) {
             super(out);
@@ -645,14 +645,14 @@
             try {
                 String expectedLine = in.readLine();
                 if (!bufferedLine.equals(expectedLine)) {
-                    unequalLines.add("\n" + new Integer(line) + ":" + bufferedLine );
+                    unequalLines.add("\n" + line + " expected: " +expectedLine+ " but was: " + bufferedLine );
                 }
             } catch (IOException e) {
                 
             }
         }
         
-        public List getUnequalLines() {
+        public List<String> getUnequalLines() {
             return unequalLines;
         }
     }
Index: api/src/main/java/org/teiid/translator/TypeFacility.java
===================================================================
--- api/src/main/java/org/teiid/translator/TypeFacility.java	(revision 3801)
+++ api/src/main/java/org/teiid/translator/TypeFacility.java	(working copy)
@@ -30,6 +30,7 @@
 import java.util.Date;
 import java.util.TimeZone;
 
+import org.teiid.core.types.BinaryType;
 import org.teiid.core.types.BlobType;
 import org.teiid.core.types.ClobType;
 import org.teiid.core.types.DataTypeManager;
@@ -62,6 +63,7 @@
 		public static final int CLOB = DataTypeManager.DefaultTypeCodes.CLOB;
 		public static final int XML = DataTypeManager.DefaultTypeCodes.XML;
 		public static final int NULL = DataTypeManager.DefaultTypeCodes.NULL;
+		public static final int VARBINARY = DataTypeManager.DefaultTypeCodes.VARBINARY;
 	}
 
     public interface RUNTIME_TYPES {
@@ -84,6 +86,8 @@
         public static final Class<ClobType> CLOB          = DataTypeManager.DefaultDataClasses.CLOB;
         public static final Class<XMLType> XML           = DataTypeManager.DefaultDataClasses.XML;
         public static final Class<NullType> NULL         = DataTypeManager.DefaultDataClasses.NULL;
+        public static final Class<BinaryType> VARBINARY         = DataTypeManager.DefaultDataClasses.VARBINARY;
+        
     }
     
     public static final class RUNTIME_NAMES {
@@ -106,6 +110,7 @@
         public static final String BLOB         = DataTypeManager.DefaultDataTypes.BLOB;
         public static final String CLOB         = DataTypeManager.DefaultDataTypes.CLOB;
         public static final String XML         	= DataTypeManager.DefaultDataTypes.XML;
+        public static final String VARBINARY         	= DataTypeManager.DefaultDataTypes.VARBINARY;
     }
     
     /**
Index: engine/src/main/javacc/org/teiid/query/parser/SQLParser.jj
===================================================================
--- engine/src/main/javacc/org/teiid/query/parser/SQLParser.jj	(revision 3801)
+++ engine/src/main/javacc/org/teiid/query/parser/SQLParser.jj	(working copy)
@@ -398,7 +398,8 @@
 |   < STRINGVAL: (("N"|"E")? "'" ( ("''") | ~["'"] )* "'") >
 |	< #LETTER: (["a"-"z","A"-"Z"] | ["\u0153"-"\ufffd"]) >
 |	< #DIGIT: ["0"-"9"] >
-
+|   < BINARYSTRINGVAL: ("X"|"x" "'" ( <HEXIT><HEXIT> )+ "'") >
+|	< #HEXIT: (["a"-"f","A"-"F"] | <DIGIT> ) >
 }
 
 TOKEN : /* Punctuation */
@@ -4013,6 +4014,7 @@
 				throw new ParseException(QueryPlugin.Util.getString("SQLParser.decimal_parse", params)); //$NON-NLS-1$
 			}
 		}   |
+		t=<BINARYSTRINGVAL> { constant = new Constant(new BinaryType(javax.xml.bind.DatatypeConverter.parseHexBinary(t.image.substring(2, t.image.length() - 1))), DataTypeManager.DefaultDataClasses.VARBINARY); } |
 		t=<FALSE>    { constant = new Constant(Boolean.FALSE, DataTypeManager.DefaultDataClasses.BOOLEAN); } |
 		t=<TRUE>     { constant = new Constant(Boolean.TRUE, DataTypeManager.DefaultDataClasses.BOOLEAN); }  |
         t=<UNKNOWN>  { constant = new Constant(null, DataTypeManager.DefaultDataClasses.BOOLEAN); }       |
Index: engine/src/main/java/org/teiid/dqp/internal/process/MetaDataProcessor.java
===================================================================
--- engine/src/main/java/org/teiid/dqp/internal/process/MetaDataProcessor.java	(revision 3801)
+++ engine/src/main/java/org/teiid/dqp/internal/process/MetaDataProcessor.java	(working copy)
@@ -34,10 +34,10 @@
 import org.teiid.api.exception.query.QueryResolverException;
 import org.teiid.client.metadata.MetadataResult;
 import org.teiid.client.metadata.ResultsMetadataConstants;
-import org.teiid.client.metadata.ResultsMetadataDefaults;
 import org.teiid.core.TeiidComponentException;
 import org.teiid.core.TeiidProcessingException;
 import org.teiid.core.types.DataTypeManager;
+import org.teiid.core.types.JDBCSQLTypeInfo;
 import org.teiid.core.types.XMLType;
 import org.teiid.dqp.internal.process.DQPCore.ClientState;
 import org.teiid.dqp.internal.process.DQPWorkContext.Version;
@@ -76,6 +76,8 @@
  */
 public class MetaDataProcessor {
 
+    public final static String XML_COLUMN_NAME = "xml"; //$NON-NLS-1$
+
     // Resources
     private DQPCore requestManager;
     private QueryMetadataInterface metadata;
@@ -248,10 +250,10 @@
 
     private Map createXMLColumnMetadata(Query xmlCommand) {
         GroupSymbol doc = xmlCommand.getFrom().getGroups().get(0);
-        Map xmlMetadata = getDefaultColumn(doc.getName(), ResultsMetadataDefaults.XML_COLUMN_NAME, XMLType.class);
+        Map xmlMetadata = getDefaultColumn(doc.getName(), XML_COLUMN_NAME, XMLType.class);
 
         // Override size as XML may be big        
-        xmlMetadata.put(ResultsMetadataConstants.DISPLAY_SIZE, ResultsMetadataDefaults.XML_COLUMN_LENGTH);
+        xmlMetadata.put(ResultsMetadataConstants.DISPLAY_SIZE, JDBCSQLTypeInfo.XML_COLUMN_LENGTH);
         
         return xmlMetadata;
     }
@@ -364,7 +366,7 @@
                 return precision;
             }
         }
-        return ResultsMetadataDefaults.getDefaultPrecision(dataType).intValue();
+        return JDBCSQLTypeInfo.getDefaultPrecision(dataType).intValue();
     }
     
     /**
@@ -416,7 +418,7 @@
            }
        }
        // else BOOLEAN, DATE, TIME, TIMESTAMP, CHARACTER use max
-       return ResultsMetadataDefaults.getMaxDisplaySize(dataType);
+       return JDBCSQLTypeInfo.getMaxDisplaySize(dataType);
     }
 
     public Map<Integer, Object> getDefaultColumn(String tableName, String columnName, 
@@ -441,12 +443,12 @@
         column.put(ResultsMetadataConstants.WRITABLE, Boolean.TRUE);
         column.put(ResultsMetadataConstants.CURRENCY, Boolean.FALSE);
         column.put(ResultsMetadataConstants.DATA_TYPE, DataTypeManager.getDataTypeName(javaType));
-        column.put(ResultsMetadataConstants.RADIX, ResultsMetadataDefaults.DEFAULT_RADIX);
-        column.put(ResultsMetadataConstants.SCALE, ResultsMetadataDefaults.DEFAULT_SCALE);
+        column.put(ResultsMetadataConstants.RADIX, JDBCSQLTypeInfo.DEFAULT_RADIX);
+        column.put(ResultsMetadataConstants.SCALE, JDBCSQLTypeInfo.DEFAULT_SCALE);
         column.put(ResultsMetadataConstants.SIGNED, Boolean.TRUE);
         
-        column.put(ResultsMetadataConstants.PRECISION, ResultsMetadataDefaults.getDefaultPrecision(javaType));
-        column.put(ResultsMetadataConstants.DISPLAY_SIZE, ResultsMetadataDefaults.getMaxDisplaySize(javaType));
+        column.put(ResultsMetadataConstants.PRECISION, JDBCSQLTypeInfo.getDefaultPrecision(javaType));
+        column.put(ResultsMetadataConstants.DISPLAY_SIZE, JDBCSQLTypeInfo.getMaxDisplaySize(javaType));
         return column;        
     }
     
Index: engine/src/main/java/org/teiid/query/sql/visitor/SQLStringVisitor.java
===================================================================
--- engine/src/main/java/org/teiid/query/sql/visitor/SQLStringVisitor.java	(revision 3801)
+++ engine/src/main/java/org/teiid/query/sql/visitor/SQLStringVisitor.java	(working copy)
@@ -1152,6 +1152,8 @@
                 constantParts = new String[] {"{t'", obj.getValue().toString(), "'}"}; //$NON-NLS-1$ //$NON-NLS-2$
             } else if (type.equals(DataTypeManager.DefaultDataClasses.DATE)) {
                 constantParts = new String[] {"{d'", obj.getValue().toString(), "'}"}; //$NON-NLS-1$ //$NON-NLS-2$
+            } else if (type.equals(DataTypeManager.DefaultDataClasses.VARBINARY)) {
+            	constantParts = new String[] {"X'", obj.getValue().toString(), "'"}; //$NON-NLS-1$ //$NON-NLS-2$
             }
             if (constantParts == null) {
                 String strValue = obj.getValue().toString();
Index: client/src/main/java/org/teiid/jdbc/ResultSetImpl.java
===================================================================
--- client/src/main/java/org/teiid/jdbc/ResultSetImpl.java	(revision 3801)
+++ client/src/main/java/org/teiid/jdbc/ResultSetImpl.java	(working copy)
@@ -27,20 +27,7 @@
 import java.io.Reader;
 import java.math.BigDecimal;
 import java.net.URL;
-import java.sql.Array;
-import java.sql.Blob;
-import java.sql.Clob;
-import java.sql.Date;
-import java.sql.NClob;
-import java.sql.Ref;
-import java.sql.ResultSet;
-import java.sql.ResultSetMetaData;
-import java.sql.RowId;
-import java.sql.SQLException;
-import java.sql.SQLWarning;
-import java.sql.SQLXML;
-import java.sql.Time;
-import java.sql.Timestamp;
+import java.sql.*;
 import java.util.Calendar;
 import java.util.List;
 import java.util.Map;
@@ -59,6 +46,7 @@
 import org.teiid.client.util.ResultsFuture;
 import org.teiid.core.TeiidComponentException;
 import org.teiid.core.TeiidProcessingException;
+import org.teiid.core.types.BinaryType;
 import org.teiid.core.types.BlobImpl;
 import org.teiid.core.types.BlobType;
 import org.teiid.core.types.ClobImpl;
@@ -324,6 +312,10 @@
         	String val = (String)currentValue;
         	currentValue = val.substring(0, Math.min(maxFieldSize/2, val.length()));
         }
+        else if (currentValue instanceof BinaryType) {
+        	BinaryType val = (BinaryType)currentValue;
+        	currentValue = val.getBytesDirect();
+        }
         return currentValue;
     }
     
Index: engine/src/main/java/org/teiid/common/buffer/impl/SizeUtility.java
===================================================================
--- engine/src/main/java/org/teiid/common/buffer/impl/SizeUtility.java	(revision 3801)
+++ engine/src/main/java/org/teiid/common/buffer/impl/SizeUtility.java	(working copy)
@@ -31,6 +31,7 @@
 import java.util.Map;
 import java.util.Set;
 
+import org.teiid.core.types.BinaryType;
 import org.teiid.core.types.DataTypeManager;
 
 
@@ -48,6 +49,7 @@
 	private static Set<Class<?>> VARIABLE_SIZE_TYPES = new HashSet<Class<?>>();
 	static {
 		SIZE_ESTIMATES.put(DataTypeManager.DefaultDataClasses.STRING, new int[] {100, 256});
+		SIZE_ESTIMATES.put(DataTypeManager.DefaultDataClasses.VARBINARY, new int[] {100, 256});
 		SIZE_ESTIMATES.put(DataTypeManager.DefaultDataClasses.DATE, new int[] {20, 28});
 		SIZE_ESTIMATES.put(DataTypeManager.DefaultDataClasses.TIME, new int[] {20, 28});
 		SIZE_ESTIMATES.put(DataTypeManager.DefaultDataClasses.TIMESTAMP, new int[] {20, 28});
@@ -64,6 +66,7 @@
 		SIZE_ESTIMATES.put(DataTypeManager.DefaultDataClasses.BIG_INTEGER, new int[] {75, 100});
 		SIZE_ESTIMATES.put(DataTypeManager.DefaultDataClasses.BIG_DECIMAL, new int[] {150, 200});
 		VARIABLE_SIZE_TYPES.add(DataTypeManager.DefaultDataClasses.STRING);
+		VARIABLE_SIZE_TYPES.add(DataTypeManager.DefaultDataClasses.VARBINARY);
 		VARIABLE_SIZE_TYPES.add(DataTypeManager.DefaultDataClasses.OBJECT);
 		VARIABLE_SIZE_TYPES.add(DataTypeManager.DefaultDataClasses.BIG_INTEGER);
 		VARIABLE_SIZE_TYPES.add(DataTypeManager.DefaultDataClasses.BIG_DECIMAL);
@@ -130,6 +133,12 @@
                 return alignMemory(40 + (2 * length));
             }
             return 40;
+        } else if(type == DataTypeManager.DefaultDataClasses.VARBINARY) {
+            int length = ((BinaryType)obj).getLength();
+            if (length > 0) {
+                return alignMemory(16 + length);
+            }
+            return 16;
         } else if(type == DataTypeManager.DefaultDataClasses.BIG_DECIMAL) {
         	if (!updateEstimate) {
         		return bigDecimalEstimate;
